package de.fzj.unicore.bes.impl.management;

import java.util.Map;

import de.fzj.unicore.wsrflite.Kernel;
import de.fzj.unicore.wsrflite.admin.AdminAction;
import de.fzj.unicore.wsrflite.admin.AdminActionResult;

public class ToggleBESJobSubmissionStatus implements AdminAction {

	@Override
	public String getName() {
		return "ToggleBESJobSubmission";
	}

	@Override
	public AdminActionResult invoke(Map<String, String> params, Kernel kernel) {
		boolean success=true;
		String message=null;
		BESFactoryAdmin admin = new BESFactoryAdmin();
		
		String submissionStatus = admin.isJobSubmissionEnabled();
		if(submissionStatus==null){
			success=false;
			message="No BESFactory service available at this site!";
		}
		else{
			boolean enabled=Boolean.parseBoolean(submissionStatus);
			admin.toggleJobSubmissionEnabled();
			enabled = Boolean.parseBoolean(admin.isJobSubmissionEnabled());
			message=enabled?"OK - BES job submission is now enabled" : "OK - BES job submission is disabled";
		}
		return new AdminActionResult(success,message);
	}

}
