package de.fzj.unicore.bes.security;

import java.util.Map;

/**
 * Abstract class for validating the security against some entity e.g. DB in our
 * case
 */
public abstract class SecurityValidator {
	/** Validates the security data
	 * @param securityData Name value pairs of security data
	 * @return boolean
	 *  */
	public abstract boolean validate(Map<String,String> securityData) throws SecurityException;
}
